<?php
   /*
   Plugin Name: s2Member User Logging
   Plugin URI: https://www.artificialart.co.uk
   description: s2Member User Logging & eot calendar
   Version: 1.2
   Author: tjc
   Author URI: https://www.artificialart.co.uk
   License: GPL2
   */


add_action( 'register_form', 'crf_registration_form' );
function crf_registration_form() {

	$current_user_history = $_POST['user_history'];

	?>
	<p>
		<label for="user_history"><?php esc_html_e( 'User history', 'crf' ) ?><br/>
			<textarea type="text" id="user_history" name="user_history" class="regular-text" rows="5"><?php echo esc_attr( $current_user_history ); ?></textarea>
		</label>
	</p>
	<?php
}



add_action( 'user_register', 'crf_user_register' );
function crf_user_register( $user_id ) {
	if ( ! empty( $_POST['user_history'] ) ) {
		update_user_meta( $user_id, 'user_history', sanitize_textarea_field( $_POST['user_history'] ) );
	}
}

/**
 * Back end registration
 */

//add_action( 'user_new_form', 'crf_admin_registration_form' );
function crf_admin_registration_form( $operation ) {
	if ( 'add-new-user' !== $operation ) {
		// $operation may also be 'add-existing-user'
		return;
	}

	$current_user_history = ! empty( $_POST['user_history'] ) ? sanitize_textarea_field( $_POST['user_history'] ) : '';

	?>
	<h3><?php esc_html_e( 'History', 'crf' ); ?></h3>

	<table class="form-table">
		<tr>
			<th><label for="user_history"><?php esc_html_e( 'User history', 'crf' ); ?></label> <span class="description"><?php esc_html_e( '(required)', 'crf' ); ?></span></th>
			<td>
				<textarea type="text" id="user_history" name="user_history" class="regular-text" rows="5"><?php echo esc_attr( $current_user_history ); ?></textarea>
			</td>
		</tr>
	</table>
	<?php
}

add_action( 'edit_user_created_user', 'crf_user_register' );


//Back end display
add_action( 'show_user_profile', 'crf_show_extra_profile_fields' );
add_action( 'edit_user_profile', 'crf_show_extra_profile_fields' );
function crf_show_extra_profile_fields( $user ) {
	$current_user_history = get_the_author_meta( 'user_history', $user->ID );
	?>
	<h3><?php esc_html_e( 'Personal Information', 'crf' ); ?></h3>

	<table class="form-table">
		<tr>
			<th><label for="user_history"><?php esc_html_e( 'User history', 'crf' ); ?></label></th>
			<td>
				
                ​<textarea type="text" id="user_history" name="user_history" class="regular-text" rows="5"><?php echo esc_attr( $current_user_history ); ?></textarea>

			</td>
		</tr>
	</table>
	<?php
}


//saving field
add_action( 'personal_options_update', 'crf_update_profile_fields' );
add_action( 'edit_user_profile_update', 'crf_update_profile_fields' );
function crf_update_profile_fields( $user_id ) {
	if ( ! current_user_can( 'edit_user', $user_id ) ) {
		return false;
	}

	update_user_meta( $user_id, 'user_history', $_POST['user_history'] );

}


//log user role changes
function user_role_update( $user_id, $new_role ) {
    
	$user_info = get_userdata( $user_id );
    $userRole = implode(', ', $user_info->roles);
	
	$current_user_history = get_user_meta( $user_id, 'user_history', true);
	$date = date('Y/m/d H:i:s');
	
	$new_user_history = $current_user_history . '&#10;' . $date . ' - ' . $userRole;
	
	update_user_meta( $user_id, 'user_history', $new_user_history );
	
}
add_action( 'set_user_role', 'user_role_update', 10, 2);



//add jquery eot calendar file
add_action( 'admin_enqueue_scripts', 'load_custom_script' ); 
function load_custom_script() {
  //wp_enqueue_script('custom_js_script', plugin_dir_url().'/s2member-user-logging/calendar.js', array('jquery'));
  wp_enqueue_script( 'calendar_js', plugins_url( '/calendar.js', __FILE__ ));
}